X509PublicKey Class Referenceabstract

encodes/decodes subjectPublicKeyInfo More...

`#include <asn.h>`

Inheritance diagram for X509PublicKey:

## Public Member Functions

void | BERDecode (BufferedTransformation &bt)
| decode this object from a BufferedTransformation, using BER (Basic Encoding Rules)
void | DEREncode (BufferedTransformation &bt) const
| encode this object into a BufferedTransformation, using DER (Distinguished Encoding Rules)
virtual OID | GetAlgorithmID () const =0
virtual bool | BERDecodeAlgorithmParameters (BufferedTransformation &bt)
virtual bool | DEREncodeAlgorithmParameters (BufferedTransformation &bt) const
virtual void | BERDecodePublicKey (BufferedTransformation &bt, bool parametersPresent, size_t size)=0
| decode subjectPublicKey part of subjectPublicKeyInfo, without the BIT STRING header
virtual void | DEREncodePublicKey (BufferedTransformation &bt) const =0
| encode subjectPublicKey part of subjectPublicKeyInfo, without the BIT STRING header
void | Save (BufferedTransformation &bt) const
void | Load (BufferedTransformation &bt)
virtual void | BEREncode (BufferedTransformation &bt) const
| encode this object into a BufferedTransformation, using BER More...
virtual void | AssignFrom (const NameValuePairs &source)=0
| assign values from source to this object More...
virtual bool | Validate (RandomNumberGenerator &rng, unsigned int level) const =0
| check this object for errors More...
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| throws InvalidMaterial if this object fails Validate() test
virtual bool | SupportsPrecomputation () const
virtual void | Precompute (unsigned int n)
| do precomputation More...
virtual void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| retrieve previously saved precomputation
virtual void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| save precomputation for later use
void | DoQuickSanityCheck () const
template<class T >
bool | GetThisObject (T &object) const
| get a copy of this object or a subobject of it
template<class T >
bool | GetThisPointer (T *&p) const
| get a pointer to this object, as a pointer to T
template<class T >
bool | GetValue (const char *name, T &value) const
| get a named value, returns true if the name exists
template<class T >
T | GetValueWithDefault (const char *name, T defaultValue) const
| get a named value, returns the default if the name doesn't exist
std::string | GetValueNames () const
| get a list of value names that can be retrieved
bool | GetIntValue (const char *name, int &value) const
| get a named value with type int More...
int | GetIntValueWithDefault (const char *name, int defaultValue) const
| get a named value with type int, with default
template<class T >
void | GetRequiredParameter (const char *className, const char *name, T &value) const
void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
virtual bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const =0
| to be implemented by derived classes, users should use one of the above functions instead

## Static Public Member Functions

static void | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| used by derived classes to check for type mismatch

## Detailed Description

encodes/decodes subjectPublicKeyInfo

Definition at line 245 of file asn.h.

## Member Function Documentation

virtual void ASN1Object::BEREncode | ( | BufferedTransformation & | bt | ) | const

inline virtual inherited

encode this object into a BufferedTransformation, using BER

this may be useful if DEREncode() would be too inefficient

Definition at line 1643 of file cryptlib.h.

virtual void CryptoMaterial::AssignFrom | ( | const NameValuePairs & | source | ) |

pure virtual inherited

assign values from source to this object

Note
  This function can be used to create a public key from a private key.

Implemented in DL_PublicKeyImpl< GP >, DL_PublicKeyImpl< DL_GroupParameters_EC< EC > >, DL_PrivateKeyImpl< GP >, DL_PrivateKeyImpl< DL_GroupParameters_EC< EC > >, DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP >, DL_GroupParameters_IntegerBasedImpl< DL_GroupPrecomputation_LUC, DL_BasePrecomputation_LUC >, DL_GroupParameters_IntegerBasedImpl< ModExpPrecomputation >, InvertibleRSAFunction, InvertibleESIGNFunction, InvertibleLUCFunction, InvertibleRabinFunction, InvertibleRWFunction, DL_GroupParameters_EC< EC >, DL_GroupParameters_IntegerBased, LUCFunction, RSAFunction, ESIGNFunction, RabinFunction, RWFunction, and XTR_DH.

Referenced by InvertibleRSAFunction::Save().

virtual bool CryptoMaterial::Validate | ( | RandomNumberGenerator & | rng,
|  | unsigned int | level
| ) |  | const

pure virtual inherited

check this object for errors

Parameters

  level | denotes the level of thoroughness: 0 - using this object won't cause a crash or exception (rng is ignored) 1 - this object will probably function (encrypt, sign, etc.) correctly (but may not check for weak keys and such) 2 - make sure this object will function correctly, and do reasonable security checks 3 - do checks that may take a long time

Returns
  true if the tests pass

Implemented in DL_PublicKeyImpl< GP >, DL_PublicKeyImpl< DL_GroupParameters_EC< EC > >, DL_PrivateKeyImpl< GP >, DL_PrivateKeyImpl< DL_GroupParameters_EC< EC > >, DL_GroupParameters< T >, DL_GroupParameters< Integer >, DL_GroupParameters< typenameEcPrecomputation< EC >::Element >, InvertibleRSAFunction, InvertibleESIGNFunction, InvertibleLUCFunction, InvertibleRabinFunction, InvertibleRWFunction, LUCFunction, RSAFunction, ESIGNFunction, RabinFunction, RWFunction, and XTR_DH.

Referenced by InvertibleRSAFunction::Save().

virtual bool CryptoMaterial::SupportsPrecomputation | ( |  | ) | const

inline virtual inherited

Returns
  whether this object supports precomputation

Reimplemented in DL_PublicKeyImpl< GP >, DL_PublicKeyImpl< DL_GroupParameters_EC< EC > >, DL_PrivateKeyImpl< GP >, DL_PrivateKeyImpl< DL_GroupParameters_EC< EC > >, DL_GroupParameters< T >, DL_GroupParameters< Integer >, and DL_GroupParameters< typenameEcPrecomputation< EC >::Element >.

Definition at line 1075 of file cryptlib.h.

virtual void CryptoMaterial::Precompute | ( | unsigned int | n | ) |

inline virtual inherited

do precomputation

The exact semantics of Precompute() is varies, but typically it means calculate a table of n objects that can be used later to speed up computation.

Reimplemented in DL_PublicKeyImpl< GP >, DL_PublicKeyImpl< DL_GroupParameters_EC< EC > >, DL_PrivateKeyImpl< GP >, DL_PrivateKeyImpl< DL_GroupParameters_EC< EC > >, DL_GroupParameters< T >, DL_GroupParameters< Integer >, and DL_GroupParameters< typenameEcPrecomputation< EC >::Element >.

Definition at line 1080 of file cryptlib.h.

bool NameValuePairs::GetIntValue | ( | const char * | name,
|  | int & | value
| ) |  | const

inline inherited

get a named value with type int

used to ensure we don't accidentally try to get an unsigned int or some other type when we mean int (which is the most common case)

Definition at line 281 of file cryptlib.h.

The documentation for this class was generated from the following file:

- asn.h